/* dimension2 -- first hack at multi-dimensionsal representation
	for chris' soundfile selector lisp thing

	-- now with multiple objs
*/

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <GL/glut.h>


float xval,yval,zval;

float objs[8][3]; /* 0=x; 1=y; 2=z */

void setobjs()
{
	objs[0][0] = 0.0;
	objs[0][1] = 0.0;
	objs[0][2] = 0.0;
	objs[1][0] = 0.0;
	objs[1][1] = 2.0;
	objs[1][2] = 0.0;
	objs[2][0] = 0.0;
	objs[2][1] = 0.0;
	objs[2][2] = 2.0;
	objs[3][0] = 0.0;
	objs[3][1] = 2.0;
	objs[3][2] = 2.0;
	objs[4][0] = 2.0;
	objs[4][1] = 0.0;
	objs[4][2] = 0.0;
	objs[5][0] = 2.0;
	objs[5][1] = 2.0;
	objs[5][2] = 0.0;
	objs[6][0] = 2.0;
	objs[6][1] = 0.0;
	objs[6][2] = 2.0;
	objs[7][0] = 2.0;
	objs[7][1] = 2.0;
	objs[7][2] = 2.0;
}




static void Reset()
{
   xval = 0.0;
   yval = 0.0;
   zval = 0.0;
}


static void Display( void )
{
   int i;

   glClear( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT );

   for (i = 0; i < 8; i++) {
	glPushMatrix();
		glTranslatef(xval-objs[i][0], yval-objs[i][1], zval-objs[i][2]);
		glutSolidSphere(0.5, 10, 10);
	glPopMatrix();
   }

   glutSwapBuffers();
}



static void Reshape( int width, int height )
{
   glViewport( 0, 0, width, height );
   glMatrixMode( GL_PROJECTION );
   glLoadIdentity();
   glFrustum (-1.25, 1.25, -1.0, 1.0, 1.5, 20.0);
   glMatrixMode( GL_MODELVIEW );
   glLoadIdentity();
}




static void Init()
{
   GLfloat ambient[] = { 0.0, 0.0, 0.0, 1.0 };
   GLfloat diffuse[] = { 1.0, 1.0, 1.0, 1.0 };
   GLfloat position[] = { 0.0, 3.0, 2.0, 0.0 };
   GLfloat lmodel_ambient[] = { 0.4, 0.4, 0.4, 1.0 };
   GLfloat local_view[] = { 0.0 };


   glEnable(GL_DEPTH_TEST);
   glDepthFunc(GL_LESS);

   glLightfv(GL_LIGHT0, GL_AMBIENT, ambient);
   glLightfv(GL_LIGHT0, GL_DIFFUSE, diffuse);
   glLightfv(GL_LIGHT0, GL_POSITION, position);
   glLightModelfv(GL_LIGHT_MODEL_AMBIENT, lmodel_ambient);
   glLightModelfv(GL_LIGHT_MODEL_LOCAL_VIEWER, local_view);

   glEnable(GL_LIGHTING);
   glEnable(GL_LIGHT0);

   setobjs();

   Reset();
}

static void Key( unsigned char key, int x, int y )
{
   switch (key) {
	case 'u':
		zval += 0.2;
		break;
	case 'd':
		zval -= 0.2;
		break;
	}
   glutPostRedisplay();
}

static void SpecialKey( int key, int x, int y )
{
   switch (key) {
      case GLUT_KEY_UP:
         yval += 0.2;
         break;
      case GLUT_KEY_DOWN:
         yval -= 0.2;
         break;
      case GLUT_KEY_LEFT:
         xval -= 0.2;
         break;
      case GLUT_KEY_RIGHT:
         xval += 0.2;
         break;
   }
   glutPostRedisplay();
}




int main( int argc, char *argv[] )
{

   glutInit( &argc, argv );
   glutInitWindowPosition( 0, 0 );
   glutInitWindowSize( 500, 400 );

   glutInitDisplayMode( GLUT_RGB | GLUT_DOUBLE | GLUT_DEPTH );

   glutCreateWindow(argv[0]);
 
   Init();

   glutReshapeFunc( Reshape );
   glutKeyboardFunc( Key );
   glutSpecialFunc( SpecialKey );
   glutDisplayFunc( Display );

   glutMainLoop();
   return 0;
}
