/* dimension3 -- first hack at multi-dimensionsal representation
	for chris' soundfile selector lisp thing

	-- now with multiple objs
	-- add multiple dimensions, and offset for inhabiting
		the same region of 3-space
*/

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <GL/glut.h>


float xval,yval,zval,x1val;

float objs[10][4]; /* 0=x; 1=y; 2=z; 3=x1 */

int coords[4][4][4];

void setone(int onum, float x, float y, float z, float x1)
{
	objs[onum][0] = x;
	objs[onum][1] = y;
	objs[onum][2] = z;
	objs[onum][3] = x1;

	switch ( coords[(int)x][(int)y][(int)z] ) {
		case 1:
			objs[onum][0] += 0.2;
			break;
		case 2:
			objs[onum][1] += 0.2;
			break;
		case 3:
			objs[onum][2] += 0.2;
	}
	coords[(int)x][(int)y][(int)z] += 1;
}

void setobjs()
{
	int i,j,k;
	float x,y,z,x1;

	/* set all the 3-space coords to 0, then when an object
	   in n-space maps to the same 3-space coords, we offset
	   the x/y/z coords so the two won't obscure each other */
	for (i = 0; i < 4; i++) {
		for (j = 0; j < 4; j++) {
			for (k = 0; k < 4; k++) {
				coords[i][j][k] = 0;
			}
		}
	}

	x = 0.0;
	y = 0.0;
	z = 0.0;
	x1 = 0.0;
	setone(0, x, y, z, x1);

	x = 0.0;
	y = 1.0;
	z = 0.0;
	x1 = 0.0;
	setone(1, x, y, z, x1);

	x = 1.0;
	y = 1.0;
	z = 0.0;
	x1 = 0.0;
	setone(2, x, y, z, x1);

	x = 1.0;
	y = 1.0;
	z = 0.0;
	x1 = 1.0;
	setone(3, x, y, z, x1);

	x = 1.0;
	y = 1.0;
	z = 1.0;
	x1 = 0.0;
	setone(4, x, y, z, x1);

	x = 0.0;
	y = 1.0;
	z = 1.0;
	x1 = 0.0;
	setone(5, x, y, z, x1);

	x = 0.0;
	y = 1.0;
	z = 1.0;
	x1 = 1.0;
	setone(6, x, y, z, x1);

	x = 0.0;
	y = 1.0;
	z = 1.0;
	x1 = 2.0;
	setone(7, x, y, z, x1);

	x = 0.0;
	y = 2.0;
	z = 1.0;
	x1 = 1.0;
	setone(8, x, y, z, x1);

	x = 2.0;
	y = 1.0;
	z = 1.0;
	x1 = 0.0;
	setone(9, x, y, z, x1);

}


static void Reset()
{
   xval = 0.0;
   yval = 0.0;
   zval = -5.0;
}


static void Display( void )
{
   int i;

   glClear( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT );

   for (i = 0; i < 10; i++) {
	glPushMatrix();
		glTranslatef(xval-objs[i][0], yval-objs[i][1], zval-objs[i][2]);
		glutSolidSphere(0.2, 10, 10);
	glPopMatrix();
   }

   glutSwapBuffers();
}



static void Reshape( int width, int height )
{
   glViewport( 0, 0, width, height );
   glMatrixMode( GL_PROJECTION );
   glLoadIdentity();
   glFrustum (-1.25, 1.25, -1.0, 1.0, 1.5, 20.0);
   glMatrixMode( GL_MODELVIEW );
   glLoadIdentity();
}




static void Init()
{
   GLfloat ambient[] = { 0.0, 0.0, 0.0, 1.0 };
   GLfloat diffuse[] = { 1.0, 1.0, 1.0, 1.0 };
   GLfloat position[] = { 0.0, 3.0, 2.0, 0.0 };
   GLfloat lmodel_ambient[] = { 0.4, 0.4, 0.4, 1.0 };
   GLfloat local_view[] = { 0.0 };


   glEnable(GL_DEPTH_TEST);
   glDepthFunc(GL_LESS);

   glLightfv(GL_LIGHT0, GL_AMBIENT, ambient);
   glLightfv(GL_LIGHT0, GL_DIFFUSE, diffuse);
   glLightfv(GL_LIGHT0, GL_POSITION, position);
   glLightModelfv(GL_LIGHT_MODEL_AMBIENT, lmodel_ambient);
   glLightModelfv(GL_LIGHT_MODEL_LOCAL_VIEWER, local_view);

   glEnable(GL_LIGHTING);
   glEnable(GL_LIGHT0);

   setobjs();

   Reset();
}

static void Key( unsigned char key, int x, int y )
{
   switch (key) {
	case 'u':
		zval += 0.2;
		break;
	case 'd':
		zval -= 0.2;
		break;
	}
   glutPostRedisplay();
}

static void SpecialKey( int key, int x, int y )
{
   switch (key) {
      case GLUT_KEY_UP:
         yval += 0.2;
         break;
      case GLUT_KEY_DOWN:
         yval -= 0.2;
         break;
      case GLUT_KEY_LEFT:
         xval -= 0.2;
         break;
      case GLUT_KEY_RIGHT:
         xval += 0.2;
         break;
   }
   glutPostRedisplay();
}




int main( int argc, char *argv[] )
{

   glutInit( &argc, argv );
   glutInitWindowPosition( 0, 0 );
   glutInitWindowSize( 500, 400 );

   glutInitDisplayMode( GLUT_RGB | GLUT_DOUBLE | GLUT_DEPTH );

   glutCreateWindow(argv[0]);
 
   Init();

   glutReshapeFunc( Reshape );
   glutKeyboardFunc( Key );
   glutSpecialFunc( SpecialKey );
   glutDisplayFunc( Display );

   glutMainLoop();
   return 0;
}
