/* dimension5 -- first hack at multi-dimensionsal representation
	for chris' soundfile selector lisp thing

	-- now with multiple objs
	-- add multiple dimensions, and offset for inhabiting
		the same region of 3-space
	-- coloring of extra dimensions, plus size for distance added
	-- correct size/distance, add more dimensions
	-- structure-ize the objects (for soundfile names), add more dims
	-- added more dimensions, plus the cylinders!
*/

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <GL/glut.h>


float xval,yval,zval,x1val,y1val,z1val,x2val,y2val,z2val;


#define NOBJS 50

struct obj {
	char name[10]; /* soundfile name */
	float dims[9]; /* 0=x; 1=y; 2=z; 3=x1; 4=y1; 5=z1; 6=x2; 7=y2; 8=z2 */
} objs[NOBJS]; 

#define NCOORDS 7

int coords[NCOORDS][NCOORDS][NCOORDS];


void setone(int onum, float x, float y, float z, float x1, float y1, float z1, float x2, float y2, float z2)
{
	objs[onum].dims[0] = x;
	objs[onum].dims[1] = y;
	objs[onum].dims[2] = z;
	objs[onum].dims[3] = x1;
	objs[onum].dims[4] = y1;
	objs[onum].dims[5] = z1;
	objs[onum].dims[6] = x2;
	objs[onum].dims[7] = y2;
	objs[onum].dims[8] = z2;

	switch ( coords[(int)x][(int)y][(int)z] ) {
		case 1:
			objs[onum].dims[0] += 0.2;
			break;
		case 2:
			objs[onum].dims[1] += 0.2;
			break;
		case 3:
			objs[onum].dims[2] += 0.2;
			break;
		case 4:
			objs[onum].dims[0] -= 0.2;
			break;
		case 5:
			objs[onum].dims[1] -= 0.2;
			break;
		case 6:
			objs[onum].dims[2] -= 0.2;
			break;
		case 7:
			objs[onum].dims[0] += 0.2;
			objs[onum].dims[1] += 0.2;
			break;
		case 8:
			objs[onum].dims[1] += 0.2;
			objs[onum].dims[2] += 0.2;
			break;
		case 9:
			objs[onum].dims[0] += 0.2;
			objs[onum].dims[2] += 0.2;
			break;
	}
	coords[(int)x][(int)y][(int)z] += 1;
}

void setobjs()
{
	int i,j,k;
	float x,y,z,x1,y1,z1,x2,y2,z2;

	/* set all the 3-space coords to 0, then when an object
	   in n-space maps to the same 3-space coords, we offset
	   the x/y/z coords so the two won't obscure each other */
	for (i = 0; i < NCOORDS; i++) {
		for (j = 0; j < NCOORDS; j++) {
			for (k = 0; k < NCOORDS; k++) {
				coords[i][j][k] = 0;
			}
		}
	}

	x = 0.0;
	y = 0.0;
	z = 0.0;
	x1 = 0.0;
	y1 = 0.0;
	z1 = 0.0;
	x2 = 0.0;
	y2 = 0.0;
	z2 = 0.0;
	setone(0, x, y, z, x1, y1, z1, x2, y2, z2);

	x = 0.0;
	y = 1.0;
	z = 0.0;
	x1 = 0.0;
	y1 = 0.0;
	z1 = 0.0;
	x2 = 1.0;
	y2 = 0.0;
	z2 = 0.0;
	setone(1, x, y, z, x1, y1, z1, x2, y2, z2);

	x = 1.0;
	y = 1.0;
	z = 0.0;
	x1 = 3.0;
	y1 = 4.0;
	z1 = 2.0;
	x2 = 0.0;
	y2 = 1.0;
	z2 = 0.0;
	setone(2, x, y, z, x1, y1, z1, x2, y2, z2);

	x = 1.0;
	y = 1.0;
	z = 0.0;
	x1 = 1.0;
	y1 = 0.0;
	z1 = 2.0;
	x2 = 0.0;
	y2 = 0.0;
	z2 = 0.0;
	setone(3, x, y, z, x1, y1, z1, x2, y2, z2);

	x = 1.0;
	y = 1.0;
	z = 1.0;
	x1 = 0.0;
	y1 = 6.0;
	z1 = 4.0;
	x2 = 0.0;
	y2 = 0.0;
	z2 = 1.0;
	setone(4, x, y, z, x1, y1, z1, x2, y2, z2);

	x = 0.0;
	y = 1.0;
	z = 5.0;
	x1 = 0.0;
	y1 = 3.0;
	z1 = 0.0;
	x2 = 3.0;
	y2 = 0.0;
	z2 = 0.0;
	setone(5, x, y, z, x1, y1, z1, x2, y2, z2);

	x = 2.0;
	y = 1.0;
	z = 1.0;
	x1 = 1.0;
	y1 = 2.0;
	z1 = 5.0;
	x2 = 0.0;
	y2 = 4.0;
	z2 = 5.0;
	setone(6, x, y, z, x1, y1, z1, x2, y2, z2);

	x = 3.0;
	y = 1.0;
	z = 1.0;
	x1 = 2.0;
	y1 = 6.0;
	z1 = 1.0;
	x2 = 0.0;
	y2 = 0.0;
	z2 = 0.0;
	setone(7, x, y, z, x1, y1, z1, x2, y2, z2);

	x = 0.0;
	y = 2.0;
	z = 6.0;
	x1 = 1.0;
	y1 = 1.0;
	z1 = 5.0;
	x2 = 1.0;
	y2 = 6.0;
	z2 = 0.0;
	setone(8, x, y, z, x1, y1, z1, x2, y2, z2);

	x = 2.0;
	y = 1.0;
	z = 5.0;
	x1 = 2.0;
	y1 = 0.0;
	z1 = 0.0;
	x2 = 2.0;
	y2 = 2.0;
	z2 = 2.0;
	setone(9, x, y, z, x1, y1, z1, x2, y2, z2);

	x = 3.0;
	y = 5.0;
	z = 5.0;
	x1 = 3.0;
	y1 = 0.0;
	z1 = 3.0;
	x2 = 0.0;
	y2 = 0.0;
	z2 = 1.0;
	setone(10, x, y, z, x1, y1, z1, x2, y2, z2);

	x = 3.0;
	y = 2.0;
	z = 1.0;
	x1 = 4.0;
	y1 = 1.0;
	z1 = 2.0;
	x2 = 0.0;
	y2 = 0.0;
	z2 = 1.0;
	setone(11, x, y, z, x1, y1, z1, x2, y2, z2);

	x = 6.0;
	y = 2.0;
	z = 1.0;
	x1 = 3.0;
	y1 = 0.0;
	z1 = 0.0;
	x2 = 1.0;
	y2 = 2.0;
	z2 = 3.0;
	setone(12, x, y, z, x1, y1, z1, x2, y2, z2);

	x = 2.0;
	y = 2.0;
	z = 2.0;
	x1 = 5.0;
	y1 = 0.0;
	z1 = 0.0;
	x2 = 3.0;
	y2 = 2.0;
	z2 = 1.0;
	setone(13, x, y, z, x1, y1, z1, x2, y2, z2);

	x = 2.0;
	y = 0.0;
	z = 2.0;
	x1 = 6.0;
	y1 = 6.0;
	z1 = 1.0;
	x2 = 0.0;
	y2 = 5.0;
	z2 = 5.0;
	setone(14, x, y, z, x1, y1, z1, x2, y2, z2);

	x = 2.0;
	y = 3.0;
	z = 2.0;
	x1 = 2.0;
	y1 = 2.0;
	z1 = 5.0;
	x2 = 6.0;
	y2 = 0.0;
	z2 = 6.0;
	setone(15, x, y, z, x1, y1, z1, x2, y2, z2);

	x = 0.0;
	y = 3.0;
	z = 6.0;
	x1 = 1.0;
	y1 = 4.0;
	z1 = 1.0;
	x2 = 3.0;
	y2 = 2.0;
	z2 = 0.0;
	setone(16, x, y, z, x1, y1, z1, x2, y2, z2);

	x = 2.0;
	y = 0.0;
	z = 0.0;
	x1 = 5.0;
	y1 = 1.0;
	z1 = 2.0;
	x2 = 3.0;
	y2 = 3.0;
	z2 = 4.0;
	setone(17, x, y, z, x1, y1, z1, x2, y2, z2);

	x = 2.0;
	y = 5.0;
	z = 4.0;
	x1 = 1.0;
	y1 = 0.0;
	z1 = 3.0;
	x2 = 0.0;
	y2 = 0.0;
	z2 = 4.0;
	setone(18, x, y, z, x1, y1, z1, x2, y2, z2);

	x = 0.0;
	y = 5.0;
	z = 4.0;
	x1 = 4.0;
	y1 = 4.0;
	z1 = 3.0;
	x2 = 5.0;
	y2 = 0.0;
	z2 = 0.0;
	setone(19, x, y, z, x1, y1, z1, x2, y2, z2);

	x = 1.0;
	y = 1.0;
	z = 4.0;
	x1 = 4.0;
	y1 = 3.0;
	z1 = 4.0;
	x2 = 5.0;
	y2 = 0.0;
	z2 = 4.0;
	setone(20, x, y, z, x1, y1, z1, x2, y2, z2);

	x = 6.0;
	y = 6.0;
	z = 4.0;
	x1 = 4.0;
	y1 = 3.0;
	z1 = 0.0;
	x2 = 1.0;
	y2 = 0.0;
	z2 = 6.0;
	setone(21, x, y, z, x1, y1, z1, x2, y2, z2);

	x = 1.0;
	y = 0.0;
	z = 6.0;
	x1 = 4.0;
	y1 = 2.0;
	z1 = 5.0;
	x2 = 0.0;
	y2 = 6.0;
	z2 = 6.0;
	setone(22, x, y, z, x1, y1, z1, x2, y2, z2);

	x = 1.0;
	y = 1.0;
	z = 3.0;
	x1 = 4.0;
	y1 = 5.0;
	z1 = 6.0;
	x2 = 0.0;
	y2 = 0.0;
	z2 = 0.0;
	setone(23, x, y, z, x1, y1, z1, x2, y2, z2);

	x = 5.0;
	y = 1.0;
	z = 4.0;
	x1 = 0.0;
	y1 = 3.0;
	z1 = 2.0;
	x2 = 0.0;
	y2 = 3.0;
	z2 = 0.0;
	setone(24, x, y, z, x1, y1, z1, x2, y2, z2);

	x = 1.0;
	y = 0.0;
	z = 4.0;
	x1 = 4.0;
	y1 = 0.0;
	z1 = 3.0;
	x2 = 0.0;
	y2 = 3.0;
	z2 = 3.0;
	setone(25, x, y, z, x1, y1, z1, x2, y2, z2);

	x = 6.0;
	y = 6.0;
	z = 6.0;
	x1 = 4.0;
	y1 = 3.0;
	z1 = 6.0;
	x2 = 5.0;
	y2 = 5.0;
	z2 = 3.0;
	setone(26, x, y, z, x1, y1, z1, x2, y2, z2);

	x = 5.0;
	y = 5.0;
	z = 5.0;
	x1 = 4.0;
	y1 = 3.0;
	z1 = 6.0;
	x2 = 0.0;
	y2 = 2.0;
	z2 = 1.0;
	setone(27, x, y, z, x1, y1, z1, x2, y2, z2);

	x = 4.0;
	y = 4.0;
	z = 4.0;
	x1 = 4.0;
	y1 = 4.0;
	z1 = 0.0;
	x2 = 2.0;
	y2 = 3.0;
	z2 = 6.0;
	setone(28, x, y, z, x1, y1, z1, x2, y2, z2);

	x = 6.0;
	y = 6.0;
	z = 0.0;
	x1 = 4.0;
	y1 = 0.0;
	z1 = 1.0;
	x2 = 0.0;
	y2 = 6.0;
	z2 = 5.0;
	setone(29, x, y, z, x1, y1, z1, x2, y2, z2);

	x = 5.0;
	y = 5.0;
	z = 5.0;
	x1 = 0.0;
	y1 = 0.0;
	z1 = 1.0;
	x2 = 2.0;
	y2 = 2.0;
	z2 = 2.0;
	setone(30, x, y, z, x1, y1, z1, x2, y2, z2);

	x = 1.0;
	y = 1.0;
	z = 4.0;
	x1 = 4.0;
	y1 = 1.0;
	z1 = 5.0;
	x2 = 1.0;
	y2 = 4.0;
	z2 = 2.0;
	setone(31, x, y, z, x1, y1, z1, x2, y2, z2);

	x = 2.0;
	y = 3.0;
	z = 4.0;
	x1 = 4.0;
	y1 = 3.0;
	z1 = 0.0;
	x2 = 3.0;
	y2 = 1.0;
	z2 = 2.0;
	setone(32, x, y, z, x1, y1, z1, x2, y2, z2);

	x = 2.0;
	y = 2.0;
	z = 2.0;
	x1 = 6.0;
	y1 = 5.0;
	z1 = 4.0;
	x2 = 0.0;
	y2 = 4.0;
	z2 = 4.0;
	setone(33, x, y, z, x1, y1, z1, x2, y2, z2);

	x = 1.0;
	y = 1.0;
	z = 6.0;
	x1 = 5.0;
	y1 = 3.0;
	z1 = 6.0;
	x2 = 0.0;
	y2 = 6.0;
	z2 = 2.0;
	setone(34, x, y, z, x1, y1, z1, x2, y2, z2);

	x = 1.0;
	y = 0.0;
	z = 0.0;
	x1 = 5.0;
	y1 = 3.0;
	z1 = 6.0;
	x2 = 0.0;
	y2 = 3.0;
	z2 = 0.0;
	setone(35, x, y, z, x1, y1, z1, x2, y2, z2);

	x = 0.0;
	y = 1.0;
	z = 3.0;
	x1 = 5.0;
	y1 = 3.0;
	z1 = 2.0;
	x2 = 1.0;
	y2 = 5.0;
	z2 = 5.0;
	setone(36, x, y, z, x1, y1, z1, x2, y2, z2);

	x = 1.0;
	y = 1.0;
	z = 6.0;
	x1 = 1.0;
	y1 = 1.0;
	z1 = 3.0;
	x2 = 4.0;
	y2 = 3.0;
	z2 = 0.0;
	setone(37, x, y, z, x1, y1, z1, x2, y2, z2);

	x = 5.0;
	y = 4.0;
	z = 2.0;
	x1 = 2.0;
	y1 = 1.0;
	z1 = 0.0;
	x2 = 3.0;
	y2 = 2.0;
	z2 = 0.0;
	setone(38, x, y, z, x1, y1, z1, x2, y2, z2);

	x = 0.0;
	y = 1.0;
	z = 2.0;
	x1 = 3.0;
	y1 = 4.0;
	z1 = 5.0;
	x2 = 2.0;
	y2 = 3.0;
	z2 = 0.0;
	setone(39, x, y, z, x1, y1, z1, x2, y2, z2);

	x = 3.0;
	y = 3.0;
	z = 2.0;
	x1 = 3.0;
	y1 = 3.0;
	z1 = 0.0;
	x2 = 3.0;
	y2 = 0.0;
	z2 = 1.0;
	setone(40, x, y, z, x1, y1, z1, x2, y2, z2);

	x = 6.0;
	y = 1.0;
	z = 6.0;
	x1 = 4.0;
	y1 = 3.0;
	z1 = 2.0;
	x2 = 0.0;
	y2 = 0.0;
	z2 = 1.0;
	setone(41, x, y, z, x1, y1, z1, x2, y2, z2);

	x = 3.0;
	y = 2.0;
	z = 5.0;
	x1 = 0.0;
	y1 = 0.0;
	z1 = 6.0;
	x2 = 0.0;
	y2 = 1.0;
	z2 = 1.0;
	setone(42, x, y, z, x1, y1, z1, x2, y2, z2);

	x = 1.0;
	y = 0.0;
	z = 0.0;
	x1 = 4.0;
	y1 = 3.0;
	z1 = 4.0;
	x2 = 3.0;
	y2 = 6.0;
	z2 = 1.0;
	setone(43, x, y, z, x1, y1, z1, x2, y2, z2);

	x = 1.0;
	y = 1.0;
	z = 6.0;
	x1 = 1.0;
	y1 = 1.0;
	z1 = 1.0;
	x2 = 0.0;
	y2 = 2.0;
	z2 = 0.0;
	setone(44, x, y, z, x1, y1, z1, x2, y2, z2);

	x = 6.0;
	y = 3.0;
	z = 4.0;
	x1 = 0.0;
	y1 = 1.0;
	z1 = 2.0;
	x2 = 4.0;
	y2 = 2.0;
	z2 = 1.0;
	setone(45, x, y, z, x1, y1, z1, x2, y2, z2);

	x = 3.0;
	y = 5.0;
	z = 2.0;
	x1 = 4.0;
	y1 = 3.0;
	z1 = 1.0;
	x2 = 0.0;
	y2 = 6.0;
	z2 = 0.0;
	setone(46, x, y, z, x1, y1, z1, x2, y2, z2);

	x = 1.0;
	y = 0.0;
	z = 0.0;
	x1 = 4.0;
	y1 = 3.0;
	z1 = 0.0;
	x2 = 3.0;
	y2 = 6.0;
	z2 = 0.0;
	setone(47, x, y, z, x1, y1, z1, x2, y2, z2);

	x = 1.0;
	y = 6.0;
	z = 2.0;
	x1 = 6.0;
	y1 = 6.0;
	z1 = 3.0;
	x2 = 4.0;
	y2 = 1.0;
	z2 = 1.0;
	setone(48, x, y, z, x1, y1, z1, x2, y2, z2);

	x = 3.0;
	y = 5.0;
	z = 2.0;
	x1 = 5.0;
	y1 = 0.0;
	z1 = 5.0;
	x2 = 4.0;
	y2 = 6.0;
	z2 = 2.0;
	setone(49, x, y, z, x1, y1, z1, x2, y2, z2);

}


static void Reset()
{
   xval = 0.0;
   yval = 0.0;
   zval = -5.0;
   x1val = 0.0;
   y1val = 0.0;
   z1val = 0.0;
   x2val = 0.0;
   y2val = 0.0;
   z2val = 0.0;
}

float calcdist(float x, float y, float z, float x1, float y1, float z1, float x2, float y2, float z2) {
	return((float)sqrt(x*x + y*y + z*z + x1*x1 + y1*y1 + z1*z1 + x2*x2 + y2*y2 + z2*z2));
}

static void Display( void )
{
   int i;
   float colx,coly,colz,size;
   float dist;
   float x2cyl,y2cyl,z2cyl;
   GLUquadricObj *q;

   glClear( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT );



   for (i = 0; i < NOBJS; i++) {
	glPushMatrix();
		glTranslatef(xval-objs[i].dims[0], yval-objs[i].dims[1], zval-objs[i].dims[2]);
		colx = (objs[i].dims[3]-x1val)/(float)NCOORDS;
		coly = (objs[i].dims[4]-y1val)/(float)NCOORDS;
		colz = (objs[i].dims[5]-z1val)/(float)NCOORDS;
		glColor3f(colx, coly, colz);

		x2cyl = (objs[i].dims[6]-x2val)/(float)NCOORDS;
		glPushMatrix();
   			glRotatef(90, 1.0, 0.0, 0.0);
   			q = gluNewQuadric();
			gluQuadricDrawStyle( q, GLU_FILL );
			gluQuadricNormals(q, GL_SMOOTH);
			gluCylinder(q, 0.1, 0.1, x2cyl, 14, 1);
			gluDeleteQuadric(q);
		glPopMatrix();
		y2cyl = (objs[i].dims[7]-y2val)/(float)NCOORDS;
		glPushMatrix();
   			glRotatef(90, 0.0, 1.0, 0.0);
   			q = gluNewQuadric();
			gluQuadricDrawStyle( q, GLU_FILL );
			gluQuadricNormals(q, GL_SMOOTH);
			gluCylinder(q, 0.1, 0.1, y2cyl, 14, 1);
			gluDeleteQuadric(q);
		glPopMatrix();
		z2cyl = (objs[i].dims[8]-z2val)/(float)NCOORDS;
		glPushMatrix();
   			glRotatef(90, 0.0, 0.0, 1.0);
   			q = gluNewQuadric();
			gluQuadricDrawStyle( q, GLU_FILL );
			gluQuadricNormals(q, GL_SMOOTH);
			gluCylinder(q, 0.1, 0.1, z2cyl, 14, 1);
			gluDeleteQuadric(q);
		glPopMatrix();

		dist = calcdist(objs[i].dims[0]-xval,objs[i].dims[1]-yval,
			objs[i].dims[2]-zval,objs[i].dims[3]-x1val,
			objs[i].dims[4]-y1val,objs[i].dims[5]-z1val,
			objs[i].dims[6]-x2val, objs[i].dims[7]-y2val,
			objs[i].dims[8]-z2val);
		size = 2.0/dist;
		if (size > 2.0) size = 2.0;
		glutSolidSphere(size, 10, 10);
	glPopMatrix();
   }

   glutSwapBuffers();
}



static void Reshape( int width, int height )
{
   glViewport( 0, 0, width, height );
   glMatrixMode( GL_PROJECTION );
   glLoadIdentity();
   glFrustum (-1.25, 1.25, -1.0, 1.0, 1.5, 20.0);
   glMatrixMode( GL_MODELVIEW );
   glLoadIdentity();
}




static void Init()
{
   GLfloat ambient[] = { 0.0, 0.0, 0.0, 1.0 };
   GLfloat diffuse[] = { 1.0, 1.0, 1.0, 1.0 };
   GLfloat position[] = { 0.0, 3.0, 2.0, 0.0 };
   GLfloat lmodel_ambient[] = { 0.4, 0.4, 0.4, 1.0 };
   GLfloat local_view[] = { 0.0 };

        GLfloat diffuseMaterial[4];



        glShadeModel(GL_SMOOTH);

        glMaterialfv(GL_FRONT, GL_DIFFUSE, diffuseMaterial);
        glColorMaterial(GL_FRONT, GL_DIFFUSE);
        glEnable(GL_COLOR_MATERIAL);


   glEnable(GL_DEPTH_TEST);
   glDepthFunc(GL_LESS);

   glLightfv(GL_LIGHT0, GL_AMBIENT, ambient);
   glLightfv(GL_LIGHT0, GL_DIFFUSE, diffuse);
   glLightfv(GL_LIGHT0, GL_POSITION, position);
   glLightModelfv(GL_LIGHT_MODEL_AMBIENT, lmodel_ambient);
   glLightModelfv(GL_LIGHT_MODEL_LOCAL_VIEWER, local_view);

   glEnable(GL_LIGHTING);
   glEnable(GL_LIGHT0);

   setobjs();

   Reset();
}

static void Key( unsigned char key, int x, int y )
{
   switch (key) {
	case 'u':
		zval += 0.2;
		break;
	case 'd':
		zval -= 0.2;
		break;
	case 'a':
		x1val += 0.2;
		break;
	case 's':
		x1val -= 0.2;
		break;
	case 'z':
		y1val += 0.2;
		break;
	case 'x':
		y1val -= 0.2;
		break;
	case 'q':
		y1val += 0.2;
		break;
	case 'w':
		y1val -= 0.2;
		break;
	case 'e':
		x2val += 0.2;
		break;
	case 'r':
		x2val -= 0.2;
		break;
	case 'f':
		y2val += 0.2;
		break;
	case 'g':
		y2val -= 0.2;
		break;
	case 'c':
		z2val += 0.2;
		break;
	case 'v':
		z2val -= 0.2;
		break;
	}
   glutPostRedisplay();
}

static void SpecialKey( int key, int x, int y )
{
   switch (key) {
      case GLUT_KEY_UP:
         yval += 0.2;
         break;
      case GLUT_KEY_DOWN:
         yval -= 0.2;
         break;
      case GLUT_KEY_LEFT:
         xval -= 0.2;
         break;
      case GLUT_KEY_RIGHT:
         xval += 0.2;
         break;
   }
   glutPostRedisplay();
}




int main( int argc, char *argv[] )
{

   glutInit( &argc, argv );
   glutInitWindowPosition( 0, 0 );
   glutInitWindowSize( 500, 400 );

   glutInitDisplayMode( GLUT_RGB | GLUT_DOUBLE | GLUT_DEPTH );

   glutCreateWindow(argv[0]);
 
   Init();

   glutReshapeFunc( Reshape );
   glutKeyboardFunc( Key );
   glutSpecialFunc( SpecialKey );
   glutDisplayFunc( Display );

   glutMainLoop();
   return 0;
}
