/* dimension8 -- first hack at multi-dimensionsal representation
	for chris' soundfile selector lisp thing

	-- now with multiple objs
	-- add multiple dimensions, and offset for inhabiting
		the same region of 3-space
	-- coloring of extra dimensions, plus size for distance added
	-- correct size/distance, add more dimensions
	-- structure-ize the objects (for soundfile names), add more dims
	-- added more dimensions, plus the cylinders!
	-- now including chris' data for parsing
	-- constructing choose-list, plus RTcmix stubs, etc.
*/

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <GL/glut.h>

#include "/musr/cmix/H/RTsockfuncs.h"
#include "/musr/cmix/H/randfuncs.h"

int theSock; /* the socket */
int RTpid; /* the process id of CMIX so we can kill it */



float xval,yval,zval,x1val,y1val,z1val,x2val,y2val,z2val;


#define NOBJS 250

int totobjs;

struct obj {
	char name[50]; /* soundfile name */
	float dims[9]; /* 0=x; 1=y; 2=z; 3=x1; 4=y1; 5=z1; 6=x2; 7=y2; 8=z2 */
	float dur; /* duration of soundfile */
} objs[NOBJS]; 

#define NCOORDS 8

int coords[NCOORDS][NCOORDS][NCOORDS];

int choices[NOBJS]; /* contains objs references within the distance */
int nchoices; /* how many there are */


void setone(int onum, float x, float y, float z, float x1, float y1, float z1, float x2, float y2, float z2)
{
	objs[onum].dims[0] = x;
	objs[onum].dims[1] = y;
	objs[onum].dims[2] = z;
	objs[onum].dims[3] = x1;
	objs[onum].dims[4] = y1;
	objs[onum].dims[5] = z1;
	objs[onum].dims[6] = x2;
	objs[onum].dims[7] = y2;
	objs[onum].dims[8] = z2;

	switch ( coords[(int)x][(int)y][(int)z] ) {
		case 1:
			objs[onum].dims[0] += 0.2;
			break;
		case 2:
			objs[onum].dims[1] += 0.2;
			break;
		case 3:
			objs[onum].dims[2] += 0.2;
			break;
		case 4:
			objs[onum].dims[0] -= 0.2;
			break;
		case 5:
			objs[onum].dims[1] -= 0.2;
			break;
		case 6:
			objs[onum].dims[2] -= 0.2;
			break;
		case 7:
			objs[onum].dims[0] += 0.2;
			objs[onum].dims[1] += 0.2;
			break;
		case 8:
			objs[onum].dims[1] += 0.2;
			objs[onum].dims[2] += 0.2;
			break;
		case 9:
			objs[onum].dims[0] += 0.2;
			objs[onum].dims[2] += 0.2;
			break;
	}
	coords[(int)x][(int)y][(int)z] += 1;
}

void setobjs()
{
	int i,j,k;
	float x,y,z,x1,y1,z1,x2,y2,z2;
	int iarr[8];
	FILE *fd;

	/* set all the 3-space coords to 0, then when an object
	   in n-space maps to the same 3-space coords, we offset
	   the x/y/z coords so the two won't obscure each other */
	for (i = 0; i < NCOORDS; i++) {
		for (j = 0; j < NCOORDS; j++) {
			for (k = 0; k < NCOORDS; k++) {
				coords[i][j][k] = 0;
			}
		}
	}

	/* open up the data file created with bparse.lisp */
	fd = fopen("TDATA", "r");
	if (fd == NULL) {
		fprintf(stderr, "couldn't open the TDATA file for some reason...\n");
		exit(-1);
	}

	i = 0;
	while(fscanf(fd,"%s %f %i %i %i %i %i %i %i",objs[i].name,&(objs[i].dur), iarr, iarr+1, iarr+2, iarr+3, iarr+4, iarr+5, iarr+6) != EOF) {

		x = iarr[1]; /* loudness */
		y = iarr[2]; /* att-hard */
		z = iarr[3]; /* noisy/harm */
		x1 = iarr[4]; /* color */
		y1 = iarr[5]; /* agitation */
		z1 = iarr[6]; /* tessitura */
		if (iarr[0] == 0) { /* the pitch thing -- do this better */
			x2 = 0.0;
		} else {
			x2 = 7.0;
		}
		y2 = 0.0; /* add the material here */
		z2 = 0.0;
		setone(i, x, y, z, x1, y1, z1, x2, y2, z2);

		if (++i >= NOBJS) {
			fprintf(stderr, "exceeded number of objects, overwriting last one\n");
			i--;
		}
	}

	totobjs = i;
}


static void Reset()
{
   xval = 4.3;
   yval = 4.5;
   zval = -2.5;
   x1val = 0.0;
   y1val = 0.0;
   z1val = 0.0;
   x2val = 0.0;
   y2val = 0.0;
   z2val = 0.0;
}

float calcdist(float x, float y, float z, float x1, float y1, float z1, float x2, float y2, float z2) {
	return((float)sqrt(x*x + y*y + z*z + x1*x1 + y1*y1 + z1*z1 + x2*x2 + y2*y2 + z2*z2));
}

static void Display( void )
{
   int i;
   float colx,coly,colz,size;
   float dist;
   float x2cyl,y2cyl,z2cyl;
   GLUquadricObj *q;

   glClear( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT );



   nchoices = 0;
   for (i = 0; i < totobjs; i++) {
	glPushMatrix();
		glTranslatef(xval-objs[i].dims[0], yval-objs[i].dims[1], zval-objs[i].dims[2]);
		colx = (objs[i].dims[3]-x1val)/(float)NCOORDS;
		coly = (objs[i].dims[4]-y1val)/(float)NCOORDS;
		colz = (objs[i].dims[5]-z1val)/(float)NCOORDS;
		glColor3f(colx, coly, colz);

		x2cyl = (objs[i].dims[6]-x2val)/(float)NCOORDS;
		glPushMatrix();
   			glRotatef(90, 1.0, 0.0, 0.0);
   			q = gluNewQuadric();
			gluQuadricDrawStyle( q, GLU_FILL );
			gluQuadricNormals(q, GL_SMOOTH);
			gluCylinder(q, 0.03, 0.03, x2cyl, 14, 1);
			gluDeleteQuadric(q);
		glPopMatrix();
		y2cyl = (objs[i].dims[7]-y2val)/(float)NCOORDS;
		glPushMatrix();
   			glRotatef(90, 0.0, 1.0, 0.0);
   			q = gluNewQuadric();
			gluQuadricDrawStyle( q, GLU_FILL );
			gluQuadricNormals(q, GL_SMOOTH);
			gluCylinder(q, 0.03, 0.03, y2cyl, 14, 1);
			gluDeleteQuadric(q);
		glPopMatrix();
		z2cyl = (objs[i].dims[8]-z2val)/(float)NCOORDS;
		glPushMatrix();
   			glRotatef(90, 0.0, 0.0, 1.0);
   			q = gluNewQuadric();
			gluQuadricDrawStyle( q, GLU_FILL );
			gluQuadricNormals(q, GL_SMOOTH);
			gluCylinder(q, 0.03, 0.03, z2cyl, 14, 1);
			gluDeleteQuadric(q);
		glPopMatrix();

		dist = calcdist(objs[i].dims[0]-xval,objs[i].dims[1]-yval,
			objs[i].dims[2]-zval,objs[i].dims[3]-x1val,
			objs[i].dims[4]-y1val,objs[i].dims[5]-z1val,
			objs[i].dims[6]-x2val, objs[i].dims[7]-y2val,
			objs[i].dims[8]-z2val);
		size = 1.0/dist;
		if (size > 2.0) size = 2.0;
		if (dist < 10.0) {
			glColor3f(1.0, 1.0, 1.0);
			choices[nchoices++] = i;
		}
		glutSolidSphere(size, 10, 10);
	glPopMatrix();
   }

printf("nchoices: %d\n",nchoices);
for (i = 0; i < nchoices; i++) printf("		%s\n",objs[choices[i]].name);

   glutSwapBuffers();
}



static void Reshape( int width, int height )
{
   glViewport( 0, 0, width, height );
   glMatrixMode( GL_PROJECTION );
   glLoadIdentity();
   glFrustum (-1.25, 1.25, -1.0, 1.0, 1.5, 20.0);
   glMatrixMode( GL_MODELVIEW );
   glLoadIdentity();
}




static void Init()
{
   GLfloat ambient[] = { 0.0, 0.0, 0.0, 1.0 };
   GLfloat diffuse[] = { 1.0, 1.0, 1.0, 1.0 };
   GLfloat position[] = { 0.0, 3.0, 2.0, 0.0 };
   GLfloat lmodel_ambient[] = { 0.4, 0.4, 0.4, 1.0 };
   GLfloat local_view[] = { 0.0 };

        GLfloat diffuseMaterial[4];



        glShadeModel(GL_SMOOTH);

        glMaterialfv(GL_FRONT, GL_DIFFUSE, diffuseMaterial);
        glColorMaterial(GL_FRONT, GL_DIFFUSE);
        glEnable(GL_COLOR_MATERIAL);


   glEnable(GL_DEPTH_TEST);
   glDepthFunc(GL_LESS);

   glLightfv(GL_LIGHT0, GL_AMBIENT, ambient);
   glLightfv(GL_LIGHT0, GL_DIFFUSE, diffuse);
   glLightfv(GL_LIGHT0, GL_POSITION, position);
   glLightModelfv(GL_LIGHT_MODEL_AMBIENT, lmodel_ambient);
   glLightModelfv(GL_LIGHT_MODEL_LOCAL_VIEWER, local_view);

   glEnable(GL_LIGHTING);
   glEnable(GL_LIGHT0);

   setobjs();

   Reset();
}

static void Key( unsigned char key, int x, int y )
{
   switch (key) {
	case 'u':
		zval += 0.07;
		break;
	case 'd':
		zval -= 0.07;
		break;
	case 'a':
		x1val += 0.07;
		break;
	case 's':
		x1val -= 0.07;
		break;
	case 'z':
		y1val += 0.07;
		break;
	case 'x':
		y1val -= 0.07;
		break;
	case 'q':
		y1val += 0.07;
		break;
	case 'w':
		y1val -= 0.07;
		break;
	case 'e':
		x2val += 0.07;
		break;
	case 'r':
		x2val -= 0.07;
		break;
	case 'f':
		y2val += 0.07;
		break;
	case 'g':
		y2val -= 0.07;
		break;
	case 'c':
		z2val += 0.07;
		break;
	case 'v':
		z2val -= 0.07;
		break;
	case 'h':
		Reset();
		break;
	}
   glutPostRedisplay();
}

static void SpecialKey( int key, int x, int y )
{
   switch (key) {
      case GLUT_KEY_UP:
         yval += 0.2;
         break;
      case GLUT_KEY_DOWN:
         yval -= 0.2;
         break;
      case GLUT_KEY_LEFT:
         xval -= 0.2;
         break;
      case GLUT_KEY_RIGHT:
         xval += 0.2;
         break;
   }
   glutPostRedisplay();
}




int main( int argc, char *argv[] )
{
   void gosound();

   /* RTcmix setup */
/*
   RTpid = RTopensocket(0, "CMIX");
   sleep(3);

   theSock = RTsock("localhost", 0);

   RTsendsock("rtsetparams", theSock, 2, 44100.0, 2.0);
*/
   RTtimeit(2.0, gosound);


   glutInit( &argc, argv );
   glutInitWindowPosition( 0, 0 );
   glutInitWindowSize( 500, 400 );

   glutInitDisplayMode( GLUT_RGB | GLUT_DOUBLE | GLUT_DEPTH );

   glutCreateWindow(argv[0]);
 
   Init();

   glutReshapeFunc( Reshape );
   glutKeyboardFunc( Key );
   glutSpecialFunc( SpecialKey );
   glutDisplayFunc( Display );

   glutMainLoop();
   return 0;
}

void gosound()
{
	int nsound;
	float dur;

	if (nchoices == 0) {
		RTtimeit(1.0, gosound);
		return;
	}

	nsound = brrand() * (float)nchoices;
	dur = objs[nsound].dur;

printf("would have chosen: %s, dur: %f\n",objs[nsound].name, dur);

/*
	RTsendsock("rtinput", theSock, 1, objs[nsound].name);
	RTsendsock("MIX", theSock, 6, 0.0, 0.0, dur, 1.0, 0.0, 1.0);
*/

	RTtimeit(dur/2.0, gosound);
}
